####
#### racc version
####
                           ####
class CFParser
rule

  file    : kv_list opteol

  kv_list : opteol IDENT ':' vals
              {
                result = { val[1] => val[3] }
              }
          | opteol idents block
              {
                result = { val[1] => val[2] }
              }
          | kv_list eols IDENT ':' vals
              {
                val[0][ val[2] ] = val[4]
              }
          | kv_list eols idents block
              {
                val[0][ val[2] ] = val[3]
              }

  block   : '{' kv_list opteol '}'
              {
                result = val[1]
              }

  val     : IDENT
          | QUOTE
  
  eols    : EOL
              {
                @lineno += 1
              }
          | eols EOL
              {
                @lineno += 1
              }

  opteol  :
          | eols

  idents  : IDENT
              {
                result = val
              }
          | idents opteol IDENT
              {
                result.push val[2]
              }

  vals    : val
              {
                result = val
              }
          | vals val
              {
                result.push val[1]
              }

end

---- inner

  def parse( f, fname )
    @fname = fname

    @q = []
    f.each do |line|
      until line.empty? do
        case line
        when /\A\s+/
          ;
        when /\A[^:"\s{}]+/
          @q.push [:IDENT, $&]
        when /\A"(?:[^"\\]+|\\.)*"/
          @q.push [:QUOTE, eval($&)]
        when /\A./
          @q.push [$&, $&]
        else
          raise RuntimeError, "must not happen"
        end
        line = $'
      end
      @q.push [:EOL, :EOL]
    end
    @q.push [false, '$']

    @lineno = 1
    @yydebug = $DEBUG
    do_parse
  end

  def next_token
    @q.shift
  end

  def on_error( t, v, _values )
    raise Racc::ParseError,
          "in #{@fname}:#{@lineno}: parse error on #{v.inspect}"
  end

