#
# theme_convert.rb: tDiary 1.4 ѥơޤ 1.5 Ѥ*Ƥȡ*Ѵ
#
# Ȥ: $ ruby theme_convert.rb hoge.css
#         ȼ¹Ԥȡhoge-2.css  hoge-simple.css ޤ
#         hoge-2.css  1.5 ѤѴ줿 CSS եǤ
#         ٤Ϥ CSS եǽƤ
#         hoge-simple.css ϺѤΰե
#
#         ץȤƴޤޤƤ tdiary1 Τ褦˥ơ
#         ǥ쥯ȥ䤹Ǥ礦
#
# Copyright (c) 2002 NT <nt@24i.net>
# Distributed under the GPL
#

require './parse'
require 'erb/erbl'

def simplify_css ( fname )
  comment = false

  File.open( fname.sub( /\.css/, "-simple.css" ), "w" ) do |f|
    File.open( fname, "r" ) do |file|
      file.each {|line|
        if %r[/\*] =~ line && %r[\*/] =~ line
        elsif %r[/\*] =~ line
          comment = true
        elsif %r[\*/] =~ line
          comment = false
        elsif comment == true
        else
          f.puts line.gsub( /[Aa]:/, "a%" )
        end
      }
    end
  end
end

def parse_css ( fname )
  result = Hash.new

  File.open( fname ) do |f|
    orig_hash = CFParser.new.parse( f, ARGV[0] )
    orig_hash.each_key{|key|
      tmp = orig_hash.shift
      result[tmp[0].join(" ")] = tmp[1]
    }
  end

  result
end

def theme_convert ( fname, hash )

  table = [
	["p\.adminmenu ","div.adminmenu {"],
	["p\.calendar ","div.calendar {"],
	["span\.date ","h2 span.date {"],
	["span\.title ","h2 span.title {"],
	["h3\.subtitle ","h3 {"],
	["p ","div.section p {"],
	["p\.commenttitle ","div.comment div.caption {"],
	["p\.referer ","div.referer {"],
	["p\.referertitle ","div.refererlist div.caption {"],
	["ul\.referer ","div.refererlist ul {"],
	["p\.footer ","div.footer {"],
	["blockquote ","div.body blockquote {"],
	["dl ","div.body dl {"],
	["dt ","div.body dt {"],
	["dd ","div.body dd {"],
	["div\.day span\.panchor ","div.day span.sanchor {"],
  ]
  flag = false

  File.open ( fname.sub( /\.css/, "-2.css" ), "w" ) do |f|
    while line = ARGF.gets
      if /\{/ =~ line
        table.each_with_index{|x, i|
          if %r[^#{x[0]}] =~ line
            f.puts x[1]
            break
          elsif %r[span\.commentator] =~ line # span.commentator ä
            flag = true
          elsif i == table.size - 1 && %r[^#{x[0]}] !~ line
            f.puts line
          end
        }
      else
        if flag && /}/ =~ line # span.commentator ä³
          flag = false
        elsif flag
        else
          f.puts line
        end
      end
    end
  end 

  rcss = File::readlines( "append.rcss" ).join
  File.open ( fname.sub( /\.css/, "-2.css" ), "a" ) do |f|
    f.write( ERbLight::new( rcss ).result( binding ) )
  end
end 

cssname = ARGV[0]
simplify_css( cssname )

parse_result = parse_css( cssname.sub( /\.css/, "-simple.css" ) )
if $CHECK
  parse_result.each{|key, val|
    print "#{key} => "
    p val
  }
end

theme_convert( cssname, parse_result )
puts %Q[Conversion completed: #{cssname.sub( /\.css/, "-2.css" )} was generated.]
